
{$INCLUDE LsComp.inc}

unit LsPicEditorRegD7;

interface

uses SysUtils, Controls, Graphics, TypInfo, LsPicEditorMainD7, LsPicEditorViewD7,
     Forms,
{$IFDEF D6_OR_HIGHER}
   DesignIntf, DesignEditors   //2.4
{$ELSE}
   DsgnIntf
{$ENDIF};

type
 TLsPictureEditor = class(TClassProperty)
 public
  function GetAttributes: TPropertyAttributes; override;
  procedure Edit; override;
 end;

procedure Register;

implementation



function TLsPictureEditor.GetAttributes: TPropertyAttributes;
begin
 Result := [paDialog]
end;

procedure TLsPictureEditor.Edit;
begin
  Application.CreateForm(TPEMainForm, PEMainForm);
  Application.CreateForm(TPEViewForm, PEViewForm);
  with PEMainForm do
  try
    if GetPropType <> nil then   //2.5>
    begin
      if (GetPropType^.Name = 'TIcon') then
        Image1.Picture.Icon := TIcon(GetOrdValue)
      else
        Image1.Picture := TPicture(GetOrdValue);
      Image2.Picture := Image1.Picture;

      if ShowModal = mrOk then
      begin
        if (GetPropType^.Name = 'TIcon') then
          SetOrdValue(LongInt(Image1.Picture.Icon))
        else if (GetPropType^.Name = 'TPicture') then
          SetOrdValue(LongInt(Image1.Picture))
        else
          SetOrdValue(LongInt(Image1.Picture.Bitmap));
      end;
    end;  //2.5<
  finally
    Close;
  end; { finally }
  PEViewForm.Close;
end;

procedure Register;
begin
  RegisterPropertyEditor(TypeInfo(TPicture), nil, '', TLsPictureEditor);
  RegisterPropertyEditor(TypeInfo(TBitmap), nil, '', TLsPictureEditor);
  RegisterPropertyEditor(TypeInfo(TIcon), nil, '', TLsPictureEditor);  //2.5
end;

end.